package oop3_dat3_u;

/**
 * Definieren Sie ein Interface IList für eine Liste,
 * die Objekte des Typs Integer (Wrapper Klasse) aufnehmen kann.
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public interface IList
{

    /**
     * add()
     * Diese Methode erhält ein Integer-Objekt und gibt nichts zurück.
     * Das Objekt wird in die Liste eingefügt.
     */
    public void add(Integer value);

    /**
     * remove()
     * Diese Methode erhält ein Integer-Objekt. Dieses wird (ein Vorkommen) aus
     * der Liste entfernt. Wenn das Objekt entfernt werden konnte, gibt die
     * Methode true zurück, andernfalls false.
     */
    public boolean remove(Integer value);

    /**
     * removeValue()
     * Diese Methode erhält einen ganzzahligen Wert und entfernt ein
     * Integer-Objekt mit diesem Wert. Konnte ein solches Objekt entfernt
     * werden, gibt die Methode true zurück, false sonst.
     */
    public boolean removeValue(int value);

    /**
     * removeValues()
     * Diese Methode erhält einen ganzzahligen Wert und entfernt alle
     * Integer-Objekte mit diesem Wert. Konnten alle Objekte entfernt werden,
     * gibt die Methode true zurück, false sonst.
     */
    public boolean removeValues(int value);

    /**
     * size()
     * Diese Methode gibt die Anzahl Elemente in der Liste zurück.
     */
    public int size();

    /**
     * exists()
     * Diese Methode erhält einen ganzzahligen Wert. Sie gibt true zurück, falls
     * ein Integer-Objekt mit diesem Wert existiert, false sonst.
     */
    public boolean exists(int value);

    /**
     * print()
     * Diese Methode gibt alle Werte der Integer-Objekte in der Liste aus.
     */
    public void print();
}
